
//your own function to capture the spin results
function myResult(e)
{

    var w = woo_wheel_index.winning_title,
    
    x = woo_wheel_index.winning_text_coupon;
    var cart_redirect = woo_wheel_index.enable_cart_redirect;

    var cart_redirect_enable = woo_wheel_index.enable_cart_redirect_settings
 
    var r = e.resultValue
    , n = '<div class="play-end"><button id="done-playing" >' + woo_wheel_index.spin_done_text + "</div >";

    setTimeout(
        function () { 
            if(e.couponType == "no_prize") {
                w = woo_wheel_index.lossing_title;
                x = woo_wheel_index.lossing_text;
                save_log(e.couponType, e.resultValue, e.msg);
            }

            else if("coupon_auto" == e.couponType) {
                save_log(e.couponType, e.resultValue, e.msg);
                var s = { 
                    action: "generating_coupon",
                    amount: e.resultValue,
                    security: woo_wheel_index.ajax_nonce
                };
                jQuery.post(
                    woo_wheel_index.ajax_url,s, function ( response ) { 
                        jQuery(".ww-toast-value").html('<input type="text" id="wheel-result" name="win_coupon_code" readonly value="'+response+'" />');
                        if(cart_redirect_enable == 'yes') {
                            window.location.href = cart_redirect;
                        }
                    }
                );
            }

            else if("coupon" == e.couponType) {
                save_log(e.couponType, e.resultValue, e.msg);
                var s = { 
                    action: "generated_coupon",
                    security: woo_wheel_index.ajax_nonce,
                    couponValue: e.resultValue,
                };

                jQuery.post(
                    woo_wheel_index.ajax_url,s, function ( response ) { 
                        jQuery(".ww-toast-value").html('<input type="text" id="wheel-result" name="win_coupon_code" readonly value="'+response+'" />');
                        if(cart_redirect_enable == 'yes') {
                            window.location.href = cart_redirect;
                        }
                    }
                );
            }

            if ("coupon_auto" == e.couponType || "coupon" == e.couponType || "link" == e.couponType) {
                jQuery(".toast").html('<p class="ww-toast-title">' + w + '</p><p class="ww-toast-text">' + x + '</p><p class="ww-toast-value"><input type="text" name="win_coupon_code" id="wheel-result" readonly value="' + r + '" /></p>' + n);
                //     if(cart_redirect_enable == 'yes') {
                //  window.location.href = cart_redirect;
                //  }
            }
            else{
                jQuery(".toast").html('<p class="ww-toast-title">' + w + '</p><p class="ww-toast-text">' + x + '</p><p class="ww-toast-value">' + r + '</p>' + n);
            }


            jQuery('#done-playing').click(
                function () {
                    woo_wheel_close();
                }
            );

    
        }, 1000
    );
  


    if(e.userData) {
      
        //console.log('User defined score: ' + e.userData.score)

    }

    /*  if(e.spinCount == 3){
    show the game progress when the spinCount is 3
    console.log(e.target.getGameProgress());
    restart it if you like
    e.target.restart();
    }*/  

}


//your own function to capture any errors
function myError(e)
{
    //e is error object
    console.log('Spin Count: ' + e.spinCount + ' - ' + 'Message: ' +  e.msg);

}

function myGameEnd(e)
{
  
    //e is gameResultsArray
    console.log(e);
    //reset the wheel at the end of the game after 5 seconds
    /* TweenMax.delayedCall(5, function(){
    
    Spin2WinWheel.reset();

    })*/


}


jQuery(document).ready(
    function (jQuery) {
        jQuery.ajax(
            {
                type: 'GET',
                url: woo_wheel_index.ajax_url,
                data: {
                    action: 'woo_spin_wheel',
                },
                success: function (response) {
                    var jsonData = JSON.parse(response);
                    //if you want to spin it using your own button, then create a reference and pass it in as spinTrigger
                    var mySpinBtn = document.querySelector('.spinBtn');
                    //create a new instance of Spin2Win Wheel and pass in the vars object
                    var myWheel = new Spin2WinWheel();
                    myWheel.init({data:jsonData, onResult:myResult, onGameEnd:myGameEnd, onError:myError, spinTrigger: mySpinBtn});
                },
                error: function (xhr, status, error) {
                    console.error('Error:', error);
                }
            }
        );
    }
)
