function popup_close_trigger() {
    jQuery(".ww-close-popup, .ww-close-popup-txt, #done-playing").click(function () {
        woo_wheel_close()
    })
}
function is_mob_hide() {
    var e = !1;
    return jQuery(window).width() < 768 && "yes" == woo_wheel_display.hide_on_mob && (jQuery("#wheel-wrapper").hide(), e = !0), e
}
function is_mobile() {
    var e = !1;
    return jQuery(window).width() < 768 && (e = !0), e
}
function user_can_play() {
    e = !0;
    if (0 == woo_wheel_display.occurance_delay) return e;
    if (woo_wheel_display.number_of_plays >= woo_wheel_display.occurance_delay) var e = !1;
    return e
}
function wait(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
let sliderOpened = false; 
async function woo_wheel_open()
{
    if (sliderOpened) return;
    let delay = woo_wheel_display.appearance_delay !== "" ? woo_wheel_display.appearance_delay : 2;
    if (!is_mob_hide() && user_can_play()) {
                sliderOpened = true;
                await wait(delay + '000'); 
                jQuery("#wheel-wrapper").fadeIn();
                jQuery("body").css("overflow-y", "hidden");
                jQuery("#wheel-wrapper").animate({ left: "0%" }, "fast", "linear");
                jQuery("#snowflakeContainer").fadeIn();
  
      

    }
     
}
function woo_wheel_close() {

    var e = "-60%";
    if (is_mobile()) {
        e = "-100%";
    }
    sliderOpened = true;
    jQuery("body").css("cssText", "overflow-y:scroll");

    jQuery("#wheel-wrapper").animate(
        {
            left: e
        }, 
        600, // Slower animation duration (600ms)
        "linear", 
        function () {
            jQuery("#wheel-wrapper").fadeOut(600); // Fade out slowly (600ms)
            jQuery("#snowflakeContainer").fadeOut(600); // Also fade out the snowflake slowly (600ms)
        }
    );
}
function spin_start() {
    jQuery(".ww-details").fadeOut()
}

var c = jQuery('input[name="win_coupon_code"]').val()
function save_log(e, o, t,c) {
    jQuery(".spinBtn").text("Processing...");
    var r = {
        action: "save_log",
        couponType: e,
        coponValue: o,
        resultText: t,
        couponCode: c,
        security: woo_wheel_display.ajax_nonce
    };
    jQuery.post(woo_wheel_display.ajax_url, r, function (e) {
        "Request Blocked!" == e ? jQuery(".ww-details").fadeOut(function () {
            jQuery(".toast").html('<p class="ww-toast-title">Request Blocked</p><p class="ww-toast-text">Limit is over</p>'), jQuery(".ww-logo").hide(), jQuery(".toast").show()
        }) : jQuery(".ww-details").fadeOut(function () {
            jQuery(".ww-logo").hide(), jQuery(".toast").show()
        })
    })
}
function copy_clipboard() {
    jQuery("#wheel-result").click(function () {
        jQuery(this).focus(), jQuery(this).select(), document.execCommand("copy"), alert("copied to clipboard");
    });
}


jQuery(document).ready(function () {
    var isOpen = false;  
    var idleTime = 0;

    // Increment idleTime every minute (60000 milliseconds)
    let seconds = woo_wheel_display.idle_time.trim() == '' ? 60000 : woo_wheel_display.idle_time + '000';
    var idleInterval = setInterval(timerIncrement, seconds);

    // Reset idleTime on any user interaction
    jQuery(document).on('mousemove keydown scroll', function() {
        idleTime = 0;
    });

    function timerIncrement() {
        idleTime += 60000; // Increment by 1 minute

        // we can also get settings options from localizations and check here  if all pages/posts are selected then this functionality
        // must be work mean show the wheel after a minute on a page or post.
        
        if ( woo_wheel_display.idle_time.trim() != '' && idleTime >= woo_wheel_display.idle_time) {
            // User has been idle for the specified time, open the wheel
            woo_wheel_open();
        }
    }

    // Function to check if the wheel should be opened based on scroll position
    async function checkScrollPosition() {
        var scrollPosition = jQuery(window).scrollTop();
        var windowHeight = jQuery(window).height();
        var documentHeight = jQuery(document).height();
        var scrollPercentage = (scrollPosition / (documentHeight - windowHeight)) * 100;
        // if scroll trigger fields are not set.
        if( woo_wheel_display.scroll_trigger_percentage_desktop.trim() =='' &&
            woo_wheel_display.scroll_trigger_percentage_mobile.trim() =='' ) {
            return;
        }
        // Check if the scroll position is greater than or equal to the specified percentage
          if ((scrollPercentage >= woo_wheel_display.scroll_trigger_percentage_desktop && !isOpen) ||
            (scrollPercentage >= woo_wheel_display.scroll_trigger_percentage_mobile && !isOpen)){
            // Open the wheel using your custom function
            var e = 2;
            if(  woo_wheel_display.appearance_delay != 0 || woo_wheel_display.appearance_delay != '' ) {
                e = woo_wheel_display.appearance_delay;
                
            }
                woo_wheel_open()
        }

        
    }

    // Call the checkScrollPosition function on scroll
    jQuery(window).on('scroll', function() {
        checkScrollPosition();
    });
    popup_close_trigger(), jQuery(".spin_wheel_icon").on('click',function () {
        sliderOpened = false;
        woo_wheel_open();
    });
    
}), jQuery(window).on('load',function () {
    "undefined" != typeof wheel_triggered && 1 == wheel_triggered && (woo_wheel_open(), wheel_triggered = 0);
});


// Exit Intent
jQuery(document).on('mouseleave', function(e) {
    if ( woo_wheel_display.d_exit_intent == 'yes' && e.clientY < 0 && wooWheelGetCookie( 'd_exit_intent' ) == '' ) {
        woo_wheel_open();
        wooWheelSetCookie( 'd_exit_intent', 1 );
    }
});


function wooWheelSetCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    var expires = "expires=" + d.toUTCString();
    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

function wooWheelGetCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}

jQuery(document).on('touchstart', function(){
    jQuery('body').addClass('on-mobile-device');
});

function myScrollSpeedFunction() {
    if (jQuery('body').hasClass('on-mobile-device') && woo_wheel_display.m_exit_intent == 'yes') {
        if (my_scroll() < -100 && wooWheelGetCookie('m_exit_intent') == '' ) {
            //Your code here to display Exit Intent popup
            woo_wheel_open();
            wooWheelSetCookie('m_exit_intent', 1);
        }
    }
}

var my_scroll = (function () { //Function that checks the speed of scrolling
    var last_position, new_position, timer, delta, delay = 50;
    function clear() {
        last_position = null;
        delta = 0;
    }

    clear();
    return function () {
        new_position = window.scrollY;
        if (last_position != null) {
            delta = new_position - last_position;
        }
        last_position = new_position;
        clearTimeout(timer);
        timer = setTimeout(clear, delay);
        return delta;
    };
})();

jQuery(document).on('scroll', myScrollSpeedFunction);

// logic for display wheel icon on mobile and other screen
jQuery(document).ready(function () {

    if( jQuery(window).width() > 768 ) {
        jQuery(".spin_wheel_icon").show();
    }
    else if(jQuery(window).width() < 768 && "no" == woo_wheel_display.hide_on_mob) {
        jQuery(".spin_wheel_icon").show();
    }

    else if(jQuery(window).width() < 768 && "yes" == woo_wheel_display.hide_on_mob) {
        jQuery(".spin_wheel_icon").remove();
    }
    else {
        jQuery(".spin_wheel_icon").show();
    }

})